package com.bib.essensbestellungsverwaltung;
/*
    @author Malte Schulze Hobeling
 */

import java.util.Scanner;

public class ConsoleMain {
    static long currentUserId = -1;
    static boolean isWorker = false;
    static boolean isParent = false;
    public static void main(String[] args) {
        boolean firstRun = Database.init();
        if(firstRun){
            Database.createDb();
            Database.fillDb();
            ConsoleLib.createWorkerPrompt();
        }
        while (true){
            if(currentUserId == -2){
                break;
            }else if(currentUserId < 0){
                defaultMenu();
            }else{
                if(isWorker){
                    adminMenu();
                }else if(isParent){
                    parentMenu();
                }
            }
        }
    }

    public static void defaultMenu(){
        System.out.println("1: Login");
        System.out.println("2: Essensplan anzeigen");
        System.out.println("3: Programm beenden");

        System.out.print("Auswahl: ");
        Scanner sc = new Scanner(System.in);
        String selection = sc.nextLine();
        switch (selection) {
            case "1" -> {
                currentUserId = ConsoleLib.loginPrompt();
                isWorker = AccountMgr.isWorker(String.valueOf(currentUserId));
                isParent = AccountMgr.isParent(String.valueOf(currentUserId));
            }
            case "2" -> ConsoleLib.showFood_planPrompt();
            case "3" -> currentUserId = -2;
        }
    }

    public static void adminMenu(){
        System.out.println("0: Ausloggen");
        System.out.println("1: Einen neuen Mitarbeiter anlegen");
        System.out.println("2: Ein neues Elternteil anlegen");
        System.out.println("3: Ein neues Kind anlegen");
        System.out.println("4: Kind einem Elternteil zuordnen");
        System.out.println("5: Ein neues Essen anlegen");
        System.out.println("6: Table");
        System.out.println("7: Einen Essensplan erstellen");
        System.out.println("8: Essensplan anzeigen");
        System.out.println("9: Löschen");
        System.out.println("10: Essen auswählen");
        System.out.println("11: Bestellungen des Tages sammeln");
        System.out.println("12: Monatsabrechnung");
        System.out.println("13: Preis ändern");


        System.out.print("Auswahl: ");
        Scanner sc = new Scanner(System.in);
        String selection = sc.nextLine();
        switch (selection) {
            case "0" -> {
                currentUserId = -1;
                isWorker = false;
                isParent = false;
            }
            case "1" -> ConsoleLib.createWorkerPrompt();
            case "2" -> ConsoleLib.createParentPrompt();
            case "3" -> ConsoleLib.createChildPrompt(String.valueOf(currentUserId));
            case "4" -> ConsoleLib.matchParentChildPrompt(String.valueOf(currentUserId));
            case "5" -> ConsoleLib.createFoodPrompt();
            case "6" -> ConsoleLib.tablePrompt();
            case "7" -> ConsoleLib.createFood_planPrompt();
            case "8" -> ConsoleLib.showFood_planPrompt();
            case "9" -> ConsoleLib.deletePrompt();
            case "10" -> ConsoleLib.createFood_selectionPrompt();
            case "11" -> ConsoleLib.dayOrderPrompt();
            case "12" -> ConsoleLib.invoicePrompt();
            case "13" -> ConsoleLib.changePricePrompt();
        }

    }

    public static void parentMenu(){
        System.out.println("0: Ausloggen");
        System.out.println("3: Ein neues Kind anlegen");
        System.out.println("4: Kind einem Elternteil zuordnen");


        System.out.print("Auswahl: ");
        Scanner sc = new Scanner(System.in);
        String selection = sc.nextLine();
        switch (selection) {
            case "0" -> {
                currentUserId = -1;
                isWorker = false;
                isParent = false;
            }
            case "3" -> ConsoleLib.createChildPrompt(String.valueOf(currentUserId));
            case "4" -> ConsoleLib.matchParentChildPrompt(String.valueOf(currentUserId));
            case "6" -> ConsoleLib.tablePrompt();
            default -> {
            }
        }

    }

}
